﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using static System.Windows.Forms.VisualStyles.VisualStyleElement;

// yabu
using System.Threading;
using System.IO;
using System.Runtime.Remoting.Contexts;
using System.Runtime.InteropServices;

namespace server
{
    public partial class Form1 : Form
    {
        int port_no;
        int nconnect = 0;
        bool start = false;
        bool isRunning = true;
        Thread accept_thread;
        TcpListener listener;
        List<TcpClient> client_list = new List<TcpClient>();
        List<Thread> threads = new List<Thread>();

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (int.TryParse(textBox1.Text, out port_no))
            {
            }
            else
            {
                textBox3.AppendText("port no が不正です\r\n");
                return;
            }
            accept_thread = new Thread(AcceptThread);
            accept_thread.Start();
            start = true;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            end_manage();
            Application.Exit();
        }

        private void add_item(string item) {
            comboBox1.Invoke((MethodInvoker)(() => {
                comboBox1.Items.Add(item);
            }));
        }

        private void delete_item(string item)
        {
            if (isRunning == false) return;

            comboBox1.Invoke((MethodInvoker)(() => {
                comboBox1.Items.Remove(item);
                textBox4.Focus();
                comboBox1.Text = "";
            }));
        }

        /*
                private void write_recvbox(string message)
                {
                    textBox2.Invoke((MethodInvoker)(() => {
                        textBox2.AppendText(message);
                    }));
                }

                private void write_message(string message) {
                    textBox3.Invoke((MethodInvoker)(() => {
                        textBox3.AppendText(message);
                    }));
                }
        */
        // ChatGPT によると上と下はほぼ同じである。

        private void write_recvbox(string text)
        {
            if (isRunning == false) return;

            if (textBox2.InvokeRequired)
            {
                textBox2.Invoke(new Action<string>(write_recvbox), text);
            }
            else
            {
                textBox2.AppendText(text);
            }
        }

        private void write_message(string text)
        {
            if (isRunning == false) return;

            if (textBox3.InvokeRequired)
            {
                textBox3.Invoke(new Action<string>(write_message), text);
            }
            else
            {
                textBox3.AppendText(text);
            }
        }

        private void AcceptThread()
        {
            try
            {
                listener = new TcpListener(IPAddress.Any, port_no);
            }
            catch (Exception ex)
            {
                write_message("サーバを起動できません\r\n");
                return;
            }
            listener.Start();
            write_message("サーバ起動\r\n");

            while (true)
            {
                try
                {
                    TcpClient client = listener.AcceptTcpClient();
                    DateTime now = DateTime.Now;
                    write_message(
                        $"====== 接続受付　at　{now.ToString("HH:mm:ss")}======\r\n");
                    IPEndPoint remoteEndPoint = client.Client.RemoteEndPoint as IPEndPoint;
                    string ipAddress = remoteEndPoint.Address.ToString();
                    int remotePort = remoteEndPoint.Port;
                    write_message($"ip address = {ipAddress}　 port no = {remotePort}\r\n");
                    Thread thread = new Thread(RecvThread);
                    threads.Add(thread);
                    thread.Start(client);
                }
                catch (Exception ex)
                {
                    write_message($"listen で例外発生: {ex.Message}\r\n");
                    return;
                }
            }

        }

        private void RecvThread(object obj)
        {
            Thread currentThread = Thread.CurrentThread;

            TcpClient client = (TcpClient)obj;
            NetworkStream stream = client.GetStream();

            client_list.Add(client);
            int socket_no = (int)client.Client.Handle;
            string socket_no_str = socket_no.ToString();

            // comboBox1.Items.Add(socket_no_str); はダメ
            // 受信した文字列を表示しなくなる。

            add_item(socket_no_str);

            byte[] buffer = new byte[1024];
            int bytesRead;
//
//  注意点
//
//　通信切断のパターンは２パターンある
//
//  相手が closesocket したときは、戻り値 0 でリターンする。
//　自分が client.Close() (stream.Close() かも) したときは、
//  例外が発生する
//
//  自分が client.Close() して例外が発生したときは、stream.Close()
//  client.Close() は二重に呼び出すことになるが、ChatGPT4o によると、
//  多重呼び出しによる弊害はないとのことなので、これで良いと思われる。
//

            try
            {
                while (true)
                {
                    bytesRead = stream.Read(buffer, 0, buffer.Length);
                    if (bytesRead > 0)
                    {
                        string receivedData =
                            Encoding.UTF8.GetString(buffer, 0, bytesRead);
                        write_recvbox($"{socket_no_str} : {receivedData}");
                    }
                    else if (bytesRead == 0)
                    {
                        write_message($"bytesRead = 0　切断されました\r\n");
//                        write_message($"<{socket_no_str}>を削除\r\n");
                        delete_item(socket_no_str);
                        //   comboBox1.Items.Remove(socket_no_str);
                        //   はスレッド上で実行してはいけない　動かない
                        nconnect--;
                        stream.Close();
                        client.Close();
                        threads.Remove(currentThread);
                        return;
                    }
                }
            }
            catch (Exception ex)
            {
//                write_message($"ReadThread 例外発生　{ex.Message}\r\n");
                write_message($"stream.Read で例外発生　切断されました\r\n");
                delete_item(socket_no_str);
                nconnect--;
                stream.Close();
                client.Close();
                threads.Remove(currentThread);
                return;
            }
        }

//      ソケット番号を表す文字列から、TcpClient のオブジェクトを返す
//      終了処理用

        private TcpClient sockno_to_client(string socket_no_str) {

            TcpClient client;

            int socket_no = int.Parse(socket_no_str);
            IntPtr p_port_no = new IntPtr(socket_no);
            client = client_list.Find
                (p => p.Client.Handle == p_port_no);
            return client;
        }

        private void textBox4_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                string[] lines = textBox4.Text.Split(new[]
                    { Environment.NewLine }, StringSplitOptions.None);
                string lastLine = lines[lines.Length - 1];
                textBox4.AppendText("\r\n");
                string lastLine2 = lastLine + "\r\n";

                if (start == true)
                {
                    byte[] data = Encoding.UTF8.GetBytes(lastLine2);

                    string socket_no_str = comboBox1.SelectedItem?.ToString();
                    if (string.IsNullOrWhiteSpace(socket_no_str) == true) { }
                    else {
                        textBox3.AppendText("socket no = " + socket_no_str 
                            + "\r\n");
                        TcpClient client;
                        client = sockno_to_client(socket_no_str);
                        NetworkStream stream = client.GetStream();
                        stream.Write(data, 0, data.Length);
                        textBox3.AppendText("send : " + socket_no_str +
                                    " : " + lastLine + "\r\n");
                    }
                }
                e.SuppressKeyPress = true;
            }
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            this.textBox4.Focus();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            string socket_no_str = comboBox1.SelectedItem?.ToString();
            if (string.IsNullOrWhiteSpace(socket_no_str) == true) { }
            else
            {
                comboBox1.Items.Remove(comboBox1.SelectedItem);
                comboBox1.Text = "";
                textBox3.AppendText(
                    $"socket no = {socket_no_str} を切断します\r\n");
                TcpClient client;
                client = sockno_to_client(socket_no_str);
                NetworkStream stream = client.GetStream();
                stream.Close();
                client.Close();
                nconnect--;
            }
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            end_manage();
        }

        private void end_manage()
        {
            TcpClient client;

            isRunning = false;

            // ソケットの解放

            if (start == true)
            {
                listener.Stop();
                foreach (var item in comboBox1.Items)
                {
                    client = sockno_to_client(item.ToString());
                    client.Close();
                    nconnect--;
                }
            }

            // スレッドの終了を試みたが挫折した
            //
            // 以下のコードではスレッドからコントロールを操作するときに
            // 発生するエラーを防げない。
            //
            // isRuning という変数を新設して、
            // スレッドからコントロールを操作する関数において、
            // false のときは return するようにした
            //
            // 従って、スレッドのリストを作り、
            //
            // ・起動するたびに登録
            // ・終了するときに削除
            //
            // をしているが、
            // 正しく動作するか確認していない。
            /*
                        accept_thread.Abort();
            //            accept_thread.Join();

                        while (threads.Count > 0)
                        {
                            Thread thread = threads[0];
                            thread.Abort();
            //                thread.Join();
                            threads.RemoveAt(0);
                        }
            */

        }
    }
}
